"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.requestJSON = exports.request = void 0;
require("whatwg-fetch");
function getCSRF() {
    var token = document.cookie.match('(^|;)\\s*csrf_token\\s*=\\s*([^;]+)');
    return token ? decodeURIComponent(token.pop() || '') : '';
}
function removeLeadingSlash(url) {
    return url.startsWith('/') ? url.substring(1, url.length) : url;
}
function removeTrailingSlash(url) {
    return url.endsWith('/') ? url.substring(0, url.length - 1) : url;
}
function applyBaseUrl(url, baseUrl) {
    return removeTrailingSlash(baseUrl) + "/" + removeLeadingSlash(url);
}
function getOptions(_a) {
    var headers = _a.headers, options = __rest(_a, ["headers"]);
    var opts = __assign({ credentials: 'same-origin', headers: __assign({ 'X-CSRF-TOKEN': getCSRF() }, headers), mode: 'same-origin' }, options);
    return opts;
}
function getUrl(url, baseUrl) {
    return baseUrl ? applyBaseUrl(url, baseUrl) : url;
}
function request(url, _a) {
    if (_a === void 0) { _a = {}; }
    var baseUrl = _a.baseUrl, options = __rest(_a, ["baseUrl"]);
    return fetch(getUrl(url, baseUrl), getOptions(options));
}
exports.request = request;
function requestJSON(url, requestParams) {
    if (requestParams === void 0) { requestParams = {}; }
    return request(url, requestParams).then(function (response) {
        return response.json();
    });
}
exports.requestJSON = requestJSON;
//# sourceMappingURL=request.js.map